import processing.core.*; 
import processing.xml.*; 

import ddf.minim.*; 
import ddf.minim.signals.*; 
import ddf.minim.analysis.*; 
import ddf.minim.effects.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class game_juan_x2 extends PApplet {

/*____________Library____________ */






/*____________Pointers____________ */
PFont Font;                                            //pointer for characters
PImage imgMain;                                        //image pointer
PImage imgConcept;
PImage imgInstruc;
PImage imgLevel;
PImage imgEnemy;                                      
PImage imgHero;
PImage imgWeapon;
PImage imgBackground;

Minim minim;                                           //Minim Class object


/*____________Arrays and ArrayList____________ */
Hero heroes;                                           //Array for heroes  
ArrayList enemies = new ArrayList();                   //dynamic creation of enemies
ArrayList weapons = new ArrayList();                   //dynamic creation of weapons


/*____________Variables____________ */
int silentMouth = 0;                                   //dead mouths
int politicians = 10;                                  //dead politicians by default
int mouthtoKill = 10;                                  //enemies to kill by default
int message = 0;                                       //end message
int gameState = 0;                                     //letter gameState main menu

AudioInput micro;                                      //for microphone
AudioPlayer heroSound;                                 //for hero's death
AudioPlayer heroWin;                                   //for hero's victory
AudioSample weaponSound;                               //for weapon
AudioSample enemySound;                                //for enemies' death
AudioSample heroHit;                                   //for hero hit


public void setup() {
  size( 567, 900 );                                    //canvas size=background image size 
  smooth();
  frameRate(25);            
  noCursor();                                          //hide cursor
  loop();
 
 /*____________Audio____________*/
  minim = new Minim(this);                             //new object of Minim
  micro = minim.getLineIn( Minim.MONO, 512 );          //collect sound of microphone in sample with a buffer size of 512                     
  heroSound = minim.loadFile("Polit_dead.wav");        //for hero dead               
  weaponSound = minim.loadSample("Shhh.wav");          //for weapon                       
  enemySound = minim.loadSample("Mouth_dead.wav");     //for enemies dead                       
  heroHit = minim.loadSample("Polit_hit.wav");         //for enemies dead                            
  heroWin = minim.loadFile("Hero_win.wav");            //for hero victory
 
 
 /*____________Font for text____________*/ 
  Font=loadFont("Cracked-32.vlw");                      //load font
  textFont(Font);
  
  
  /*____________Images____________*/
  imgMain = loadImage ("back_main.gif");
  imgConcept = loadImage ("back_concept.gif");
  imgInstruc = loadImage ("back_instruction.gif");
  imgLevel = loadImage ("back_ranking.gif");
  imgBackground = loadImage ("BackImage.gif");
  imgEnemy = loadImage ("Mouth.gif");
  imgHero = loadImage ("Money.gif");  
  imgWeapon = loadImage ("Weapon.gif");
  imgBackground = loadImage ("BackImage.gif");
  
  /*____________Hero____________*/
  heroes = new Hero(imgHero);
}



public void draw() {
  /*____________Out main menu____________*/
  if (gameState == 0)
    drawMain();
      
  /*____________Concept____________*/
  else if (gameState == 1)  // else if since there is no need to check gameState again (if it was 0, it can't be 1)
    drawConcept();
  
  /*____________Instructions____________*/
  else if (gameState == 2)
    drawInstructions();
    
  /*____________Level gameState____________*/
  else if (gameState == 3)
    drawLevelSelection();
  
  /*____________ GAME____________*/
  else if ((gameState == 4) || (gameState == 5))
  {
    if (gameState == 4)
      drawGame();
    else
      drawPause();
  }
  
  else if (gameState == 6)
    drawEndGame(message);
}


/*____________FUNCTIONS____________*/

public void drawMain() {
    background (imgMain);
    fill(0xff000000);                                               //characters colour
    textSize(20);                                                //characters size 
    text ("by whoun", 480, 250);
    text ("2012 - Interface Culture", 10, (height-10)); 
    textSize(40);
    text ("CONCEPT < c >", 190, 630);  
    text ("INSTRUCTIONS < i >", 190, 675);
    text ("START GAME < s >", 190, 720);
    textSize(80);
    text ("GAME of the SYSTEM", 35, 230); 
    fill(0xffaaaaaa); 
    text ("GAME of the SYSTEM", 37, 232);                          //create shadow  \u00b4
}  // drawMain        -> not necessary, but for long functions helpful to see what function ended here


public void drawConcept() {
    background (imgConcept);
    fill(0xff000000);
    textSize(25);                                               
    text ("main menu <q>", 10, (height-10));
    textSize(40);                                               
    text ("You are a member of the system.", 70, 300);
    text ("You control it.", 70, 340);
    text ("You play against yourself.", 70, 380);
    text ("Can you really end up with the system?", 70, 420);
    text ("Do you always win?", 70, 460);
    text ("Do you always lose?", 70, 500);
    textSize(30);                                                
    text ("GAME of the SYSTEM", 375, 25);  
    fill(0xffaaaaaa); 
    text ("GAME of the SYSTEM", 377, 27);
} // drawConcept


public void drawInstructions() {
    background (imgInstruc);
    fill(0xff000000);
    textSize(25);                                               
    text ("main menu <q>", 10, (height-10));
    textSize(30);                                               
    text ("You control the buck of money with arrow keys.", 40, 300);
    text ("Use the spacebar to shoot and shut up the voices.", 40, 340);
    text ("Making sounds you create voices.", 40, 380);
    text ("More voices, less probability of shut up them.", 40, 420);
    text ("More voices, more probability of eliminate the money bag.", 40, 460);
    text ("You can pause the game pressing < p >.", 40, 500);                                                
    text ("GAME of the SYSTEM", 375, 25);  
    fill(0xffaaaaaa); 
    text ("GAME of the SYSTEM", 377, 27);
} // drawInstructions


public void drawLevelSelection() {
  background (imgLevel);
  textSize(30); 
  fill(0xff000000);                                                                                                   
  text ("FIRST: CHOOSE VOICES LEVEL", 30, 80);
  text ("SECOND: CHOOSE BUCKS BAGS LEVEL", 30, 420);        
  text ("NOW PLAY:   press < g >", 30, 760);
  text ("GAME of the SYSTEM", 375, 25);
  fill(0xffaaaaaa);  
  text ("GAME of the SYSTEM", 377, 27);  
  fill(0xff555555);
  text ("LEVEL CHOSEN:", 60, 350);
  text ("LEVEL CHOSEN:", 60, 690);
  textSize(25);
  text ("Shut up voices level", 60, 120);
  line (60, 125, 300, 125);
  text ("< 1 >  1    -----> partner level", 60, 150);
  text ("< 2 >  10   -----> mum level", 60, 175);
  text ("< 3 >  100  -----> pissed teacher level", 60, 200);
  text ("< 4 >  500  -----> city mayor level", 60, 225);
  text ("< 5 >  1000 -----> democratically elected leader level", 60, 250);
  text ("< 6 >  1001 -----> ditactor level", 60, 275);
  text ("< 7 >  1500 -----> owner of a large international company level", 60, 300);
  text ("Bucks bags broken", 60, 460);
  line (60, 465, 300, 465);
  text ("< a >  1    -----> teen level", 60, 490);
  text ("< w >  10   -----> street gang member level", 60, 515);
  text ("< e >  100  -----> urban riot level", 60, 540);
  text ("< r >  500  -----> strike level", 60, 565);
  text ("< t >  1000 -----> citizen revolution level", 60, 590);
  text ("< y >  2000 -----> continental revolution level", 60, 615);
  text ("< u >  5000 -----> impossible level", 60, 640);
}  // drawLevelgameState

public void drawGame() {          
    fill(0xff000000);
    textSize(10);                                               
    text ("main menu <q>", 10, (height-10));
    background(imgBackground);               
    textSize(20);                                                
    text ("bucks bags alive= "+politicians, 10, 40);  
    text ("voices to shut up= "+(mouthtoKill-silentMouth), 10, 20);
    textSize(30);
    text ("GAME of the SYSTEM", 375, 25, 2);
    fill(0xffaaaaaa);
    text ("GAME of the SYSTEM", 377, 27, 1);                        
    
    /*____________Hero____________*/
    updateHeros();  
    
    /*____________Weapons draw____________*/
    updateWeapons();
    
    /*____________Enemies draw____________*/
    updateEnemies();
    
    /*____________Ending conditions____________*/
    if (silentMouth >= mouthtoKill)
    {
        message = 1;
        gameState = 6;
    }
    else if (politicians <= 0)
    {
        message = 2;     
        gameState = 6;
    }
    
};


public void drawPause() {
  fill(0xff000000);
  textSize(80);                                               
  text ("PAUSE", 200, (height/2));
  noLoop();
}


public void drawEndGame (int end){  
  if (end == 1){
    heroWin.play();
    fill(0xffffffff, 170);
    noStroke();	
    rect(0, 40, width, height);      
    fill(0xff000000);
    textSize(30);
    text ("press <q>", 235, (height/2)+40);
    textSize(60);
    text ("Wellcome to the real world", 40, height/2);
    fill(0xffaaaaaa);
    text ("Wellcome to the real world", 43, (height/2)+3);  
  }; 
  if (end == 2){
    heroes.x = 10000;
    heroes.y = 10000;
    heroSound.play();
    fill(0xffffffff, 170);
    noStroke();
    rect(0, 40, width, height);  
    fill(0xff000000);
    textSize(30);
    text ("press <q>", 235, (height/2)+40);
    textSize(120);
    text ("Voices Win!!!", 70, height/2);
    fill(0xffaaaaaa);
    text ("Voices Win!!!", 73, (height/2)+3);
  };
  
  resetGame();  // IMPORTANT: otherwise you start the new game with the same end (win or loss) as the game before
  noLoop();
};


/*____________function to get microphone level____________*/
public int microlevel(){
  //return int(random(3)); // for testing without microfone
  
  float maxLevel = 0;                                  //int cast of maxLevel
  int castmaxLevel = 0;
  for(int i = 0; i < micro.bufferSize() - 1; i++) {
    if ( abs(micro.mix.get(i)) > maxLevel ) {
      maxLevel = abs(micro.mix.get(i));
    };
  }; 
  castmaxLevel = PApplet.parseInt (maxLevel * 1.5f);               //change amount of mouths          
  return castmaxLevel;
}; 

public void updateHeros() {
  heroes.draw();
  heroes.move();
  heroes.w = imgHero.width;
  heroes.h = imgHero.height;
}

public void updateWeapons() {
  for (int i = weapons.size()-1; i>0; --i){
    Weapon w = ((Weapon)(weapons.get(i)));      //creation of a pointer to the object of Weapon Class
    w.update();
    w.draw();
    if (w.y > height)
      weapons.remove(i);                        //remove weapons out of the canvas  
  };        
}

public void updateEnemies() {
  if (silentMouth < mouthtoKill){     
    float weaponX = 0;                          //X position of each weapon
    float weaponY = 0;                          //Y position of each weapon                
    /*____________Mouths creation____________*/
    int level = microlevel();                  //call function for get micro level
    for (int i=0; i < level; ++i){
      enemies.add(new Enemy(imgEnemy));
    };

    for (int i=enemies.size()-1; i>0; --i){
      boolean removeEnemy = false;
      Enemy e = ((Enemy)(enemies.get(i)));        //creation of a pointer to the object of Enemy Class
      e.update();
      e.draw();
      for (int j = weapons.size()-1; j>0; --j){
        Weapon w = ((Weapon)(weapons.get(j)));    //creation of a pointer to the object of Weapon Class
        weaponX = w.getX();                       //call function of Weapon class to get X position of weapon
        weaponY = w.getY(); 
        
        /*____________Collision Weappon vs. Mouth____________*/
        if (e.bangWeapon(weaponX, weaponY)){       //call function in the class to check the pointer  
          silentMouth++;                          //increasing variable
          enemySound.trigger();   
          removeEnemy = true;
          weapons.remove(j);                      //remove weapons
        };
      };
    
      /*____________Collision Hero vs. Mouth____________*/
      if (e.bangHero(heroes.x, heroes.y)){         //call function in the class to check the pointer  
        heroHit.trigger();
        politicians--;                            //decreasing variable
        heroes.w = heroes.w * 1.6f;                    //increase hero size when is damaged
        heroes.h = heroes.h * 1.6f;
        removeEnemy = true;                  
      }; 
      if (removeEnemy)  
        enemies.remove(i); 
    };
  };
}

public void shootWeapon() {
  weaponSound.trigger();
  weapons.add(new Weapon(heroes.x, heroes.y, imgWeapon));
}

public void resetGame() { 
  silentMouth = 0; 
  politicians = 10;
  mouthtoKill = 10;
  message = 0;
  
  enemies.clear();
  weapons.clear();
  heroes.reset();
}

/*____________Pause____________*/
public void keyPressed() {
  
  // in all game states, the key 'q' ends the game and switches to the main menu
  switch (key) {
    case ('q'): 
      gameState = 0;
      loop();
      break;
  }
  
  // react on keys in gameState main menu
  if (gameState == 0) {
    switch (key) {
      case ('c'): 
        gameState = 1;
        break;
      case ('i'):
        gameState = 2;
        break;
      case ('s'):
        gameState = 3;
        break;
    }
    
  // react on keys in gameState game
  } else if (gameState == 4) {
    switch (key) {
        case (' '):
          shootWeapon();
          break;
        case ('p'):
          gameState = 5;  // set game state to pause mode
          break;
        case('q'):
          gameState = 0;
          break;
        case ('c'): 
          gameState = 1;
          break;
        case ('i'):
          gameState = 2;
          break;
        case ('s'):
          gameState = 3;
          break;
      }
    
  // react on keys in gameState pause  
  } else if (gameState == 5) {
    switch (key) {
      case ('p'):
        gameState = 4;  // set game state to game mode (unpause)
        loop();
        break;
    }
    
  // react on keys in gameState for level selection
  } else if (gameState == 3) {
    fill(0xff000000);
    textSize(40); 
    
    switch (key) {
      case('1'):
        mouthtoKill = 1;
        text ("partner", 200, 350);
        break;
      case('2'):
        mouthtoKill = 10;
        text ("mum", 200, 350);
        break;
      case('3'):
        mouthtoKill = 100;
        text ("pissed teacher", 200, 350);
        break;
      case('4'):
        mouthtoKill = 500;
        text ("city mayor", 200, 350);
        break;
      case('5'):
        mouthtoKill = 1000;
        text ("democratically elected leader", 200, 350);
        break;
      case('6'):
        mouthtoKill = 1001;
        text ("ditactor", 200, 350);
        break;
      case('7'):
        mouthtoKill = 1500;
        text ("owner of a large international company", 200, 350);
        break;
      case('a'):
        politicians = 1;
        text ("teen", 200, 690);
        break;
      case('w'):
        politicians = 10;
        text ("street gang member", 200, 690);
        break;
      case('e'):
        politicians = 100;
        text ("urban riot", 200, 690);
        break;
      case('r'):
        politicians = 500;
        text ("strike", 200, 690);
        break;
      case('t'):
        politicians = 1000;
        text ("citizen revolution", 200, 690);
        break;
      case('y'):
        politicians = 2000;
        text ("continental revolution", 200, 690);
        break;
      case('u'):
        politicians = 5000;
        text ("impossible", 200, 690);
        break;
      case('g'):
        gameState = 4;
        break;
     }
  }
}


/*____________stop sounds____________*/
public void stop(){
  micro.close();
  heroSound.close();
  weaponSound.close();
  enemySound.close();
  heroHit.close();
  heroWin.close();
  minim.stop();
  super.stop();
}
class Enemy {
  float x;                                      //X position
  float y;                                      //Y position
  float w;                                      //width
  float h;                                      //height
  PImage img;
  
  Enemy (PImage img){                           //Enemy class constructor
    this.img = img;                             //at the begining of constructor to be used for this.x,w and h
    this.x = (int)random(width);                //X position, only executed once at the begining
    this.y = height;
    this.w = img.width;
    this.h = img.height;

  }
  
  public void update(){
    y-= random(1, 10);                          //Enemies down movement 
    x+= sin(millis() / random (1,400)) * 4.0f;  //Enemies sinoidal movement in X 
    if (y < 30 ){                              //when Enemy arrive to the top it came back the bottom 
      y = height + (h/2);                        //new position in Y  
      x = random (0,(width-w));                //new position in X
    };
  };
  
  public boolean bangHero(float HeroX, float HeroY) {                           //function to detect collision with Hero
    return (HeroX > x && HeroX < x + w && HeroY > y && HeroY < y + h);
  }  
 
  public boolean bangWeapon(float weaponX, float weaponY) {                     //function to detect collision with weapons
    return (weaponX > x && weaponX < x + w && weaponY > y && weaponY < y + h);
  }

  public void draw(){
    noFill();
    if (x > -w && x < width){                 //only draw Enemies inside screen
      imageMode(CORNER);
      image(img, x, y, w, h);
    };
  }
}
class Hero {
  float x;                                    //X position 
  float y;                                    //Y position
  float w;                                    //width
  float h;                                    //height
  PImage img;
  
  Hero (PImage img){                          //Hero class constructor
    this.img = img;
    this.x = width/2; 
    this.y = img.height;
    this.w = img.width;
    this.h = img.height;
  }
  
  public void reset() {
    this.x = width/2; 
    this.y = img.height;
  }
  
  public void move(){
     /*----------Hero movements--------*/
    if (keyPressed){ 
      if (key == CODED){ 
        if (keyCode == LEFT)
          x = x-12;
        else if (keyCode == RIGHT)
          x = x+12;        
        else if (keyCode == UP)
          y = y-12;        
        else if (keyCode == DOWN)
          y = y+12;   
      };
    };       
    /*----------limits of the movement--------*/
    if (x < (w/2))
      x = (w/2);
    if (x > width-(w/2))
      x = width-(w/2);
    if (y < 50+(h/2))
      y = 50+(h/2);
    if (y > height-(h/2))
      y = height-(h/2);      
  };
  
  public void draw(){
    noFill();
    imageMode(CENTER);    
    image(img, x, y, w, h);
  };   
}
class Weapon {
  float x;                                //X position 
  float y;                                //Y position
  float w;                                //width
  float h;                                //height
  PImage img;
  
  Weapon (float x, float y, PImage img){  //Weapon class constructor
    this.img = img;
    this.x = x; 
    this.y = y+30;
    this.w = img.width;
    this.h = img.height;
    this.img = img;
  }

  public void update(){
    y += 6;                                //Weapon movement
    getX();
    getY(); 
  };
  
  public float getX(){                          //return X position
    return x;
  };
   
  public float getY(){                          //return Y position
     return y;
  };
  
  public void draw(){
    noFill();
    if (y < height){                     //only draw the weapons if inside the canvas
      imageMode(CENTER);
      image(img, x, y, w, h);
    };
  };

  
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "game_juan_x2" });
  }
}
